using System;
using System.Xml.Serialization;
using System.IO;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
namespace PhotoMosaic
{
    /// <summary>
    /// ݒt@C
    /// </summary>
    public class Config
    {
        private const String FileName = "Config.xml";

        private static Config _this;    //gstaticŕێ

        private AppConfig _AppConfig;   //ݒl

        public AppConfig AppConfig
        {
            get { return _AppConfig; }
        }

        /// <summary>
        /// RXgN^iO͌Ă΂Ȃj
        /// </summary>
        private Config()
        {
            Load();
        }

        /// <summary>
        /// ݒl擾iB̃CX^XԂj
        /// </summary>
        /// <returns></returns>
        public static Config GetInstance()
        {
            if (_this == null)
            {
                _this = new Config();
            }
            return _this;
        }

        /// <summary>
        /// ݒǂݍ
        /// </summary>
        private void Load()
        {
            if (!File.Exists(FileName))
            {
                //t@C珉lŕԂ
                _AppConfig = new AppConfig();
                return;
            }
            FileStream fStream = null;
            try
            {
                //fVACY
                XmlSerializer serializer = new XmlSerializer(typeof(AppConfig));
                fStream = new FileStream(FileName, FileMode.Open);
                _AppConfig = (AppConfig)serializer.Deserialize(fStream);
            }
            finally
            {
                if (fStream != null)
                {
                    fStream.Close();
                    fStream.Dispose();
                }
            }
        }

        /// <summary>
        /// ݒۑ
        /// </summary>
        public void Save()
        {
            FileStream fStream = null;
            try
            {
                //VACY
                XmlSerializer serializer = new XmlSerializer(typeof(AppConfig));
                fStream = new FileStream(FileName, FileMode.Create);
                serializer.Serialize(fStream, _AppConfig);
            }
            finally
            {
                if (fStream != null)
                {
                    fStream.Close();
                    fStream.Dispose();
                }
            }
        }

        /// <summary>
        /// iԍiHjۊǕilϊ
        /// </summary>
        /// <param name="iQtIndex">iԍ</param>
        /// <returns></returns>
        public static InterpolationMode ImageQuality(int iQtIndex)
        {
            InterpolationMode qt = InterpolationMode.Default;
            switch (iQtIndex)
            {
                case 0:
                    qt = InterpolationMode.Default;
                    break;
                case 1:
                    qt = InterpolationMode.Low;
                    break;
                case 2:
                    qt = InterpolationMode.High;
                    break;
                case 3:
                    qt = InterpolationMode.NearestNeighbor;
                    break;
                case 4:
                    qt = InterpolationMode.Bilinear;
                    break;
                case 5:
                    qt = InterpolationMode.Bicubic;
                    break;
                case 6:
                    qt = InterpolationMode.HighQualityBilinear;
                    break;
                case 7:
                    qt = InterpolationMode.HighQualityBicubic;
                    break;
            }

            return qt;
        }


    }

    /// <summary>
    /// ݒlێNX
    /// </summary>
    public class AppConfig
    {
        public AppConfig()
        {
            //lݒ
            DefaultPatternFolder = "";
            LoadFileCount = 100;
            SubFolderCheck = false;
            InitTileSize = 6;
            ThmbSize = 100;
            ThmbQuality = 0;
            SelectModeRatio = 16F;

        }
        public String DefaultPatternFolder;

        public int LoadFileCount;

        public Boolean SubFolderCheck;

        public int InitTileSize;

        public int ThmbSize;

        public int ThmbQuality;

        public float SelectModeRatio;
    }
}
