using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;
using System.Drawing.Drawing2D;

namespace PhotoMosaic
{
    public partial class FrmConfig : Form
    {
        
#region o

        private ImgStCtrl m_ctrl = null;//摜t@CǗNXiCX^X̓CtH[炤

        private Boolean _IsSave = false;
        
        /// <summary>
        /// 摜t@CRg[vpeB
        /// </summary>
        public ImgStCtrl ImgStCtrl
        {
            get { return m_ctrl; }
            set { m_ctrl = value; }
        }

        /// <summary>
        /// ۑĕꂽꍇtrue
        /// </summary>
        public Boolean IsSave
        {
            get { return _IsSave; }
        }

#endregion

#region EI
        /// <summary>
        /// RXgN^
        /// </summary>
        public FrmConfig()
        {
            InitializeComponent();

            this.FormClosed += new FormClosedEventHandler(FrmConfig_FormClosed);
            this.Load += new EventHandler(FrmConfig_Load);
            this.Disposed += new EventHandler(FrmConfig_Disposed);
        }

        /// <summary>
        /// ێ\[XJ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void FrmConfig_Disposed(object sender, EventArgs e)
        {
            m_ctrl.LoadThreadJoin();
        }

        /// <summary>
        /// ʃ[hCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void FrmConfig_Load(object sender, EventArgs e)
        {
            //ݒlZbg
            AppConfig conf = Config.GetInstance().AppConfig;
            this.txtFolder.Text = conf.DefaultPatternFolder;

            this.txtMaxRead.Text = conf.LoadFileCount.ToString();

            this.txtInitTileSize.Text = conf.InitTileSize.ToString();

            this.chkSubFolder.Checked = conf.SubFolderCheck;

            this.cmbQuality.SelectedIndex = conf.ThmbQuality;

            this.txtThmbSize.Text = conf.ThmbSize.ToString();

            this.txtSelectRatio.Text = conf.SelectModeRatio.ToString();
        }

        /// <summary>
        /// ʃN[YCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void FrmConfig_FormClosed(object sender, FormClosedEventArgs e)
        {
            //XbhғI
            m_ctrl.LoadThreadJoin();
        }

        /// <summary>
        /// ݒۑ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSave_Click(object sender, EventArgs e)
        {
            //͒l`FbN
            int iTmp;
            if (!int.TryParse(this.txtMaxRead.Text, out iTmp))
            {
                MessageBox.Show("͂ł");
                this.txtMaxRead.Focus();
                return;
            }
            if (iTmp < 1)
            {
                MessageBox.Show("1ȏ̐l͂Ă");
                this.txtMaxRead.Focus();
                return;
            }
            int iMaxFileCount = iTmp;

            if (!int.TryParse(this.txtInitTileSize.Text, out iTmp))
            {
                MessageBox.Show("͂ł");
                this.txtInitTileSize.Focus();
                return;
            }
            if (iTmp < 1)
            {
                MessageBox.Show("1ȏ̐l͂Ă");
                this.txtInitTileSize.Focus();
                return;
            }

            int iInitTileSize = iTmp;

            if (!int.TryParse(this.txtThmbSize.Text, out iTmp))
            {
                MessageBox.Show("͂ł");
                this.txtThmbSize.Focus();
                return;
            }
            if (iTmp < 1)
            {
                MessageBox.Show("1ȏ̐l͂Ă");
                this.txtThmbSize.Focus();
                return;
            }
            int iThmbSize = iTmp;

            float fSelectRatio = 0F;
            if (!float.TryParse(this.txtSelectRatio.Text, out fSelectRatio))
            {
                MessageBox.Show("͂ł");
                this.txtSelectRatio.Focus();
                return;
            }
            if (fSelectRatio < 1.0)
            {
                MessageBox.Show("1.0ȏ̐l͂Ă");
                this.txtSelectRatio.Focus();
                return;
            }

            Config conf = Config.GetInstance();
            //ǂݍރtH_ύXꂽAǂݍݍς݂̃^CUSJ
            if(this.txtFolder.Text.CompareTo(conf.AppConfig.DefaultPatternFolder) != 0)
            {
                if (m_ctrl != null)
                {
                    m_ctrl.Dispose();
                }
            }

            //ݒlۑ
            conf.AppConfig.DefaultPatternFolder = this.txtFolder.Text;
            conf.AppConfig.SubFolderCheck = this.chkSubFolder.Checked;
            conf.AppConfig.LoadFileCount = iMaxFileCount;
            conf.AppConfig.InitTileSize = iInitTileSize;
            conf.AppConfig.ThmbQuality = this.cmbQuality.SelectedIndex;
            conf.AppConfig.ThmbSize = iThmbSize;
            conf.AppConfig.SelectModeRatio = fSelectRatio;
            conf.Save();

            _IsSave = true;

            this.Close();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClose_Click(object sender, EventArgs e)
        {
            
            this.Close();
        }
#endregion

        /// <summary>
        /// tH_w{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnFolder_Click(object sender, EventArgs e)
        {
            using (FolderBrowserDialog fdlog = new FolderBrowserDialog())
            {
                fdlog.Description = "摜tH_w肵ĂB";
                fdlog.ShowNewFolderButton = false;
                if (fdlog.ShowDialog() != DialogResult.OK)
                {
                    return;
                }
                this.txtFolder.Text  = fdlog.SelectedPath;
            }
        }

        /// <summary>
        /// eXg{^iʊOɉBĂj
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            using (Form2 frm = new Form2())
            {
                frm.ImgStCtrl = m_ctrl;
                frm.ShowDialog(this);
            }
        }

        /// <summary>
        /// 摜ǂݍ݁iʊOɉBĂj
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            using(FrmProgress frm = new FrmProgress(m_ctrl))
            {
                frm.ShowDialog(this);
            }
        }

    }

}