using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using System.Threading;

namespace PhotoMosaic
{
    public partial class FrmMain : Form
    {
        //^CTCY
        private int _BaseTileSize = 4;
        //\摜
        private Bitmap _BaseImage;
        //{
        private float _ratio = 1F;
        //摜̈ʒuƑ傫
        private Rectangle _ImageRect;
        //摜̃TCY
        private Rectangle _BaseImageRect;
        //Drag
        private Boolean _bNowDrag;
        //DragJn|Cg
        private Point _MouseDownPoint = Point.Empty;
        //摜ǗNX
        private ImgStCtrl _ImgStCtrl;
        //UCN/ʏ탂[h
        private Boolean _MosaicMode = false;
        //UCNp^[TCY
        private int _TileSize ;
        //bNIuWFNg
        private static readonly object syncObject = new object();
        //`惂[hw
        private MosaicStatus _DrawRequest;

        //摜I[hɓ˓{őg嗦
        private float _SelectModeRate = 16F;
        //摜Ig
        private Rectangle _SelectSquare;
        
        //UCN摜Ǘ
        private MosaicCtrl _Mosaic;

        //\̌摜̃t@CpX
        private String _LoadedImageFilePath;

#region EI
        /// <summary>
        /// RXgN^
        /// </summary>
        public FrmMain()
        {
            InitializeComponent();

            //Cxgo^
            this.pic.MouseDown += new MouseEventHandler(pic_MouseDown);
            this.pic.MouseUp += new MouseEventHandler(pic_MouseUp);
            this.pic.MouseMove += new MouseEventHandler(pic_MouseMove);
            this.pic.MouseDoubleClick += new MouseEventHandler(pic_MouseDoubleClick);
            this.pic.Paint += new PaintEventHandler(pic_Paint);
            this.ResizeEnd += new EventHandler(Form1_ResizeEnd);

            this.Load += new EventHandler(FrmMain_Load);
            this.timer1.Tick += new EventHandler(timer1_Tick);
        }

        /// <summary>
        /// [hCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void FrmMain_Load(object sender, EventArgs e)
        {
            //o
            _ImgStCtrl = new ImgStCtrl();
            _bNowDrag = true;

            try
            {
                //ݒt@Cǂł݂
                Config.GetInstance();

            }
            catch (InvalidOperationException)
            {
                MessageBox.Show("ݒt@C̓ǂݍ݂Ɏs܂B", "ݒt@Cǂݍݎs", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Close();
            }

            _Mosaic = new MosaicCtrl(_ImgStCtrl, syncObject);

            _SelectSquare = new Rectangle(0, 0, 100, 100);
        }

        /// <summary>
        /// gp̃\[XׂăN[Abv܂B
        /// </summary>
        /// <param name="disposing">}l[W \[Xjꍇ trueAjȂꍇ false łB</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }

            if (_ImgStCtrl != null)
            {
                _ImgStCtrl.Dispose();
            }
            if (_BaseImage != null)
            {
                _BaseImage.Dispose();
            }
            if (_Mosaic != null)
            {
                _Mosaic.Dispose();
            }

            base.Dispose(disposing);
        }

#endregion

#region j[

        /// <summary>
        /// ʏ탂[hƃUCN\[h؂ւ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ؂ւ_Click(object sender, EventArgs e)
        {
            if (_ImgStCtrl.ImgStatList.Count == 0)
            {
                //^Cǂݍ܂ĂȂǂݍ
                using(FrmProgress frm = new FrmProgress(_ImgStCtrl))
                {
                    frm.ShowDialog(this);
                }
            }
            if (_ImgStCtrl.ImgStatList.Count == 0)
            {
                this.tlblStat.Text = "^Cǂݍ܂Ă܂";
            }
            else
            {
                this.tlblStat.Text = "^C:" + _ImgStCtrl.ImgStatList.Count;
            }
            if (_BaseImage == null) return;

            _MosaicMode = !_MosaicMode;

            doDraw();

        }

        private void IEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// \摜w肷
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void JOToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //t@CI[v_CAO̐ݒ

            //CX^X
            OpenFileDialog dlog = new OpenFileDialog();

            //݂̃JgfBNgiʏexêꏊfBNgɐݒ
            dlog.InitialDirectory = Directory.GetCurrentDirectory();

            //tB^ݒ
            dlog.Filter = "摜t@C (*.jpg,*.png,*gif)|*.jpg;*.png;*gif;*.bmp|"
                                            + "SẴt@C@(*.*)|*.*";

            //Is
            dlog.Multiselect = false;

            //_CAO\
            if (dlog.ShowDialog() != DialogResult.OK)
            {
                //_CAO[J]Ȃ
                return;
            }

            String sFileName = dlog.FileName;//_CAOŎw肳ꂽt@C

            //C[W[h
            NewImageLoad(sFileName);
        }


        /// <summary>
        /// ݒʕ\
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ݒSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (FrmConfig frm = new FrmConfig())
            {
                frm.ImgStCtrl = _ImgStCtrl;
                frm.ShowDialog(this);
                if (frm.IsSave)
                {
                    if (_BaseImage != null)
                    {
                        //C[Wă[h
                        NewImageLoad(_LoadedImageFilePath);
                    }
                }
            }

        }

#endregion

#region Cxg
        /// <summary>
        ///@TCYI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Form1_ResizeEnd(object sender, EventArgs e)
        {
            if (_Mosaic.Mosaic != null)
            {
                lock (syncObject)
                {
                    //EBhEړŏ͍̂̂Ń`FbN
                    if (this.pic.Width == _Mosaic.Mosaic.Width && this.pic.Height == _Mosaic.Mosaic.Height) return;
                }
            }

            if (_ImageRect.Width < this.pic.Width)
            {//摜̉EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.X = this.pic.Width / 2 - _ImageRect.Width / 2;
            }
            if (_ImageRect.Height < this.pic.Height)
            {//摜̍EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.Y = this.pic.Height / 2 - _ImageRect.Height / 2;
            }

            _Mosaic.Resize(pic.Width, pic.Height);
            //tH[ɕ`˗
            doDraw();
        }

        /// <summary>
        /// yCgCxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pic_Paint(object sender, PaintEventArgs e)
        {
            if (_BaseImage != null)
            {
                if (_MosaicMode)
                {
                    //UCN摜\
                    _Mosaic.Draw(e.Graphics);
                    if (IsSelectMode())
                    {
                        using (Pen p = new Pen(Color.Red))
                        {
                            e.Graphics.DrawRectangle(p, _SelectSquare);
                        }
                    }
                }
                else
                {
                    //ʏ摜w肳ꂽ͈͂ɕ`悷
                    e.Graphics.DrawImage(_BaseImage, _ImageRect);
                }
            }
        }

        
        /// <summary>
        /// _uNbNCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pic_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            if (e.Button == MouseButtons.Left)
            {
                if (IsSelectMode())
                {
                    //^CVK摜Ƃēǂݍ
                    int index = (_SelectSquare.Y / _SelectSquare.Height) * (int)Math.Ceiling(((float)this.pic.Width / (float)_SelectSquare.Width));
                    index += _SelectSquare.X / _SelectSquare.Width;
                    String sFilePath = _Mosaic.Mosaic.FilePathList[index];
                    NewImageLoad(sFilePath);
                    return;
                }
                else
                {
                    //_uNbNꍇA摜{Ɋg
                    stretch(e.X, e.Y, 2);
                }
            }
        }

        /// <summary>
        /// }EX_ECxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pic_MouseDown(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            if (e.Button == MouseButtons.Left)
            {  //{^ꂽꍇ
                //ꂽʒuoĂ
                _MouseDownPoint = new Point(e.X, e.Y);
            }
            else
            {   //ȊÕ{^ꂽꍇ
                _bNowDrag = false;                  //DragȂ
                _MouseDownPoint = Point.Empty;      //ꂽʒuY
            }
        }

        /// <summary>
        /// }EXAbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pic_MouseUp(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            _MouseDownPoint = Point.Empty;  //ꏊY
            if (e.Button == MouseButtons.Right)
            {
                //E{^𗣂ꂽꍇA摜1/2ɏk
                stretch(e.X, e.Y, 0.5F);
            }
            else if (e.Button == MouseButtons.Left)
            {
                
                if (_MosaicMode && _bNowDrag)
                {
                    //UCN[h̎Drag
                    //ăUCN
                    ThreadReStart();
                    doDraw();
                }
            }
            _bNowDrag = false;              //DragȂ
        }

        /// <summary>
        /// }EXړCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void pic_MouseMove(object sender, MouseEventArgs e)
        {
            if (_BaseImage == null) return; //摜ǂݍ܂ĂȂ̂ŏ𔲂

            //Drag
            if (_MouseDownPoint == Point.Empty)
            {
                if (IsSelectMode())
                {
                    //摜ZNg[h
                    _SelectSquare.X = e.X - e.X % _SelectSquare.Width;
                    _SelectSquare.Y = e.Y - e.Y % _SelectSquare.Height;
                    doDraw();
                }
                return; //{^ĂȂꍇ𔲂
            }
            if (_bNowDrag)
            {   //Drag̏ꍇ

                int x = _ImageRect.X + (int)((_MouseDownPoint.X - e.X) * _ratio);
                int y = _ImageRect.Y + (int)((_MouseDownPoint.Y - e.Y) * _ratio);
                MoveImage(x, y);
                _MouseDownPoint.X = e.X;
                _MouseDownPoint.Y = e.Y;
            }
            else
            {   //܂DragȂꍇ

                //hbOƂȂ}EẌړ͈͂擾
                Rectangle moveRect = new Rectangle(
                    _MouseDownPoint.X - SystemInformation.DragSize.Width / 2,
                    _MouseDownPoint.Y - SystemInformation.DragSize.Height / 2,
                    SystemInformation.DragSize.Width,
                    SystemInformation.DragSize.Height);

                if (!moveRect.Contains(e.X, e.Y))
                {
                    //͈͊ODragɂ
                    _bNowDrag = true;
                }
            }
        }

#endregion

        /// <summary>
        /// gk
        /// </summary>
        /// <param name="x">}EXXW</param>
        /// <param name="y">}EXYW</param>
        /// <param name="rate">{</param>
        private void stretch(int x, int y, float rate)
        {
            if (_ratio * rate < 1) return;   //{1ȉɂȂꍇ(摜菬Ȃꍇj͏Ȃ


            _ratio *= rate;  //{ύX
            if (_ratio >= _SelectModeRate)
            {
                _ratio = _SelectModeRate;
            }

            _TileSize = (int)(_ratio * _BaseTileSize);

            _SelectSquare.Width = _TileSize;
            _SelectSquare.Height = _TileSize;


            //gk̑傫ݒ
            _ImageRect.Width = (int)(_ratio * _BaseImage.Width);
            _ImageRect.Height = (int)(_ratio * _BaseImage.Height);

            //gk̈ʒuvZ
            int mx = 0;
            int my = 0;
            if (_ratio <= 1)
            {
                //̑傫ꍇiꉞ1ɐݒ肵Ȃj
                _ratio = 1;
            }
            else
            {
                //2{ȏ̏ꍇ

                //_uNbNꂽʒuSɂȂ悤Ɉʒu
                mx = (int)((x - _ImageRect.X) * rate);
                mx = -(mx - this.pic.Width / 2);

                my = (int)((y - _ImageRect.Y) * rate);
                my = -(my - this.pic.Height / 2);
            }
            ThreadReStart();
            //摜ړiŕ`j
            MoveImage(mx, my);
        }

        /// <summary>
        /// ړ
        /// </summary>
        /// <param name="x">摜ʒu</param>
        /// <param name="y">摜ʒu</param>
        private void MoveImage(int x, int y)
        {
            if (_ImageRect.Width < this.pic.Width)
            {//摜̉EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.X = this.pic.Width / 2 - _ImageRect.Width / 2;
            }
            else
            {   //摜EBhE傫ꍇ

                //摜ʒuEBhE̍[EɗȂ悤
                int mx = x >= 0 ? 0 : x;

                //摜ʒuEBhẺE[荶ɗȂ悤
                if (_ImageRect.Width + mx < this.pic.Width) mx = this.pic.Width - _ImageRect.Width;
                _ImageRect.X = mx;
            }

            if (_ImageRect.Height < this.pic.Height)
            {//摜̍EBhE菬ꍇ
                //EBhE̒ɕ\
                _ImageRect.Y = this.pic.Height / 2 - _ImageRect.Height / 2;
            }
            else
            {   //摜EBhE傫ꍇ

                //摜ʒuEBhȄ[艺ɗȂ悤
                int my = y >= 0 ? 0 : y;

                //摜ʒuEBhẺ[ɗȂ悤
                if (_ImageRect.Height + my < this.pic.Height) my = this.pic.Height - _ImageRect.Height;
                _ImageRect.Y = my;
            }

            _Mosaic.Move(_ImageRect.X, _ImageRect.Y, _ratio);
            doDraw();
        }

        /// <summary>
        /// `Jn
        /// </summary>
        private void doDraw()
        {
            if (_MosaicMode)
            {
                if (_DrawRequest == MosaicStatus.Start)
                {
                    timer1.Enabled = true;
                    _Mosaic.NewDraw(_ratio, _ImageRect, pic.Size);
                    _DrawRequest = MosaicStatus.Busy;
                }
            }
            else
            {
                timer1.Enabled = false;
            }
            this.pic.Invalidate();
            this.pic.Update();
        }

        /// <summary>
        /// ^C}[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void timer1_Tick(object sender, EventArgs e)
        {
            if (_Mosaic.Mosaic != null)
            {
                if (_Mosaic.Mosaic.MosaicStatus == MosaicStatus.End)
                {
                    //`悪IĂꍇA^C}[~
                    timer1.Enabled = false;
                }
                //Iɕ`
                this.pic.Invalidate();
            }
        }


        /// <summary>
        /// ŏ烂UCN
        /// </summary>
        private void ThreadReStart()
        {
            _DrawRequest = MosaicStatus.Start;
        }

        /// <summary>
        /// 摜I[hH
        /// </summary>
        /// <returns></returns>
        private Boolean IsSelectMode()
        {
            Boolean bRet = false;
            if (_MosaicMode)
            {
                if (_ratio >= _SelectModeRate)
                {
                    bRet = true;
                }
            }
            return bRet;
        }

        /// <summary>
        /// VK摜ǂݍ
        /// </summary>
        /// <param name="bmp"></param>
        private void NewImageLoad(String sFileName)
        {
            if (_BaseImage != null)
            {
                //ȑOɉ摜ǂݍłꍇAjĂ
                _BaseImage.Dispose();
            }

            using (FileStream fStream = new FileStream(sFileName, FileMode.Open))//t@CXg[擾
            {
                //摜ǂݍ
                _BaseImage = new Bitmap(fStream);
            }
            _LoadedImageFilePath = sFileName;
            _Mosaic.SetBaseImage(_BaseImage);

            //EBhȆ傫ƃNCAg̈̍
            int subWidth = this.Width - this.ClientSize.Width;
            int subHeight = this.Height - this.ClientSize.Height + this.statusStrip1.Height+ this.menuStrip1.Height;

            //EBhȆ傫摜̑傫ɍ킹
            this.Width = _BaseImage.Width + subWidth;
            this.Height = _BaseImage.Height + subHeight;

            //ϐ
            _ratio = 1.0F;
            _ImageRect = new Rectangle(0, 0, _BaseImage.Width, _BaseImage.Height);
            _BaseImageRect = new Rectangle(0, 0, _BaseImage.Width, _BaseImage.Height);
            _bNowDrag = false;
            _MouseDownPoint = Point.Empty;
            _MosaicMode = false;

            AppConfig conf = Config.GetInstance().AppConfig;
            _SelectModeRate = conf.SelectModeRatio;
            _BaseTileSize = conf.InitTileSize;
            _TileSize = _BaseTileSize;


            ThreadReStart();

            //tH[ɕ`˗
            doDraw();
        }

    }
}