using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.IO;

namespace PhotoMosaic
{
    /// <summary>
    /// 摜ێ
    /// </summary>
    public class ImageStatus : IDisposable
    {
        //private int _THUMB_WIDTH = 100;
        //private int _THUMB_HEIGHT = 100;
        private String _FilePath;
        private Bitmap _Thmb;
        private Color _AveColor;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="sFileName">摜t@C</param>
        public ImageStatus(String sFileName,int iThmbSize,InterpolationMode thmbQt)
        {
            using (FileStream fStream = new FileStream(sFileName, FileMode.Open))//t@CXg[擾
            {
                _FilePath = sFileName;

                //摜ǂݍ
                using (Bitmap bmp = new Bitmap(fStream))
                {
                    //TlC쐬
                    _Thmb = CreateThumbnail(bmp, iThmbSize, iThmbSize, thmbQt);
                }

                //ϐF
                _AveColor = GetAverageColor(_Thmb);
            }
        }

        /// <summary>
        /// 摜̔j
        /// </summary>
        public void Dispose()
        {
            if (_Thmb != null) _Thmb.Dispose();
        }

        /// <summary>
        /// F̍Ԃ
        /// </summary>
        /// <param name="clr">rΏƂ̐F</param>
        /// <returns>F̍</returns>
        public int GetColorSub(Color clr)
        {
            int ret = 0;
            ret += Math.Abs(_AveColor.R - clr.R);
            ret += Math.Abs(_AveColor.B - clr.B);
            ret += Math.Abs(_AveColor.G - clr.G);
            return ret;
        }

        /// <summary>
        /// 摜t@CpX
        /// </summary>
        public String FilePath
        {
            get
            {
                return _FilePath;
            }
        }

        /// <summary>
        /// TlC
        /// </summary>
        public Bitmap Thumb
        {
            get
            {
                return _Thmb;
            }
        }

        /// <summary>
        /// ϐF
        /// </summary>
        public Color AveColor
        {
            get
            {
                return _AveColor;
            }
        }

        /// <summary>
        /// TlC쐬
        /// </summary>
        /// <param name="orig">摜</param>
        /// <param name="w">TlC̕</param>
        /// <param name="h">TlC̍</param>
        /// <returns>TlC摜</returns>
        static Bitmap CreateThumbnail(Bitmap orig, int w, int h, InterpolationMode qt)
        {
            Bitmap thumbnail = new Bitmap(w, h);
            using (Graphics g = Graphics.FromImage(thumbnail))
            {
                //g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.Default;
                g.InterpolationMode = qt;
                g.DrawImage(orig, 0, 0, w, h);
            }
            return thumbnail;
        }

        /// <summary>
        /// 摜̕ϐF߂
        /// </summary>
        /// <param name="img">Ώۉ摜</param>
        /// <returns>ϐF</returns>
        static Color GetAverageColor(Bitmap img)
        {
            //using (Bitmap bmp = CreateThumbnail(img,1,1))
            //{
            //    return bmp.GetPixel(0, 0);
            //}
            //1x1̃TlCĕϐF߂
            //@̂قEEܖځGG
            //͂ŕϐF߂
            using (Bitmap bmp = new Bitmap(img))
            {
                int h = img.Height;
                int w = img.Width;
                long r = 0;
                long g = 0;
                long b = 0;
                for (int y = 0; y < h; y += 4)    //4pixel΂ŐF擾@4΂炢ȂȂ낤
                {
                    for (int x = 0; x < w; x += 4)
                    {
                        Color clr = bmp.GetPixel(x, y);
                        r += clr.R;
                        g += clr.G;
                        b += clr.B;
                    }
                }
                long div = (h >> 2) * (w >> 2);
                int br = (int)(r / div);
                int bg = (int)(g / div);
                int bb = (int)(b / div);
                return Color.FromArgb(br, bg, bb);
            }

        }
    }
}
