using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Threading;
using System.Diagnostics;
using System.IO;

namespace PhotoMosaic
{
    /// <summary>
    /// 摜ǗNX
    /// </summary>
    public class ImgStCtrl : IDisposable
    {


#region o

        private List<ImageStatus> allImg;//摜Xg

        private int _MaxRead = 0;                       //őǂݍ݃t@C
        private int _FileCount = 0;                 //ݓǂݍ񂾃t@CpX
        private int _ProcCount = 0;                 //ݓǂݍ񂾃t@C
        private Boolean _isSubDirCheck;     //TutH_ȉׂ`FbN
        private String _strDir;
        private ImageLoadStatus _ImageLoadStatus;   //摜t@Cǂݍݏ

        private Thread _ImageLoadThread;            //摜t@Cǂݍ݃Xbh

        /// <summary>
        /// TlCTCY
        /// </summary>
        public int ThmbSize = 100;

        /// <summary>
        /// TlC쐬̃ASY
        /// </summary>
        public InterpolationMode ThmbQuality;

        /// <summary>
        /// 摜Xg
        /// </summary>
        public List<ImageStatus> ImgStatList
        {
            get { return allImg; }
        }

        /// <summary>
        /// ǂݍݑΏۃt@C
        /// </summary>
        public int TargetFileCount
        {
            get { return _FileCount; }
        }

        /// <summary>
        /// ݓǂݍ񂾃t@C
        /// </summary>
        public int NowReadFileCount
        {
            get { return _ProcCount; }
        }

        /// <summary>
        /// 摜t@Cǂݍݏ
        /// </summary>
        public ImageLoadStatus ImageLoadStatus
        {
            get { return _ImageLoadStatus; }
        }

#endregion


#region EI
        /// <summary>
        /// RXgN^
        /// </summary>
        public ImgStCtrl()
        {
            allImg = new List<ImageStatus>();

            ThmbQuality = InterpolationMode.Default;
        }

        /// <summary>
        /// S摜J
        /// </summary>
        public void Dispose()
        {
            foreach (ImageStatus img in allImg)
            {
                img.Dispose();
            }
            allImg.Clear();
        }
#endregion 

        /// <summary>
        /// 摜ǉ
        /// </summary>
        /// <param name="sFileName">摜t@C</param>
        public void AddImage(String sFileName)
        {
            ImageStatus img = new ImageStatus(sFileName, ThmbSize, ThmbQuality);
            allImg.Add(img);
        }

        /// <summary>
        /// ߎlF̉摜Ԃ
        /// </summary>
        /// <param name="clr">ΏېF</param>
        /// <returns>摜</returns>
        public ImageStatus GetApproximate(Color clr)
        {
            lock (this)
            {
                int app = int.MaxValue;
                int index = 0;
                int size = allImg.Count;

                //FO[vŕ摜̒SׂāAF̍ԏȂ摜T
                for (int i = 0; i < size; i++)
                {
                    ImageStatus img = allImg[i];
                    int sub = img.GetColorSub(clr);
                    if (sub < app)
                    {
                        app = sub;
                        index = i;
                    }
                }

                return allImg[index];
            }
        }

        /// <summary>
        /// 摜ǂݍ
        /// </summary>
        /// <param name="strDir">ǂݍ݃tH_</param>
        /// <param name="isSubDir">TutH_ǂށH</param>
        /// <param name="iMaxRead">őǂݍ݃t@C</param>
        public void LoadImage(String strDir, Boolean isSubDir,int iMaxRead)
        {
            _isSubDirCheck = isSubDir;
            _strDir = strDir;
            if (String.IsNullOrEmpty(_strDir))
            {
                _strDir = ".";
            }

            _MaxRead = iMaxRead;

            LoadThreadJoin();//UI点

            _ImageLoadThread = new Thread(new ThreadStart(LoadImageFile));
            _ImageLoadStatus = ImageLoadStatus.Start;
            _ImageLoadThread.Start();
        }

        /// <summary>
        /// ǂݍ݃Xbh~
        /// <br />
        /// ǂݍ݃XbhI܂ŃCXbh~܂
        /// </summary>
        public void LoadThreadJoin()
        {
            if (_ImageLoadThread != null)
            {
                if (_ImageLoadThread.IsAlive)
                {
                    _ImageLoadStatus = ImageLoadStatus.End;
                    _ImageLoadThread.Join();
                }
            }
        }

        /// <summary>
        /// ǂݍ݈ꎞ~
        /// </summary>
        public void LoadSuspend()
        {
            _ImageLoadStatus = ImageLoadStatus.Stop;
        }

        /// <summary>
        /// ǂݍݍĊJ
        /// </summary>
        public void LoadResume()
        {
            _ImageLoadStatus = ImageLoadStatus.Busy;
        }

#region t@Cǂݍ

        /// <summary>
        /// 摜t@Cǂݍ
        /// </summary>
        private void LoadImageFile()
        {
            Debug.WriteLine("摜ǂݍ݃XbhJn:" + _strDir);

            //t@CpXꗗ擾
            List<String> list = null;
            _FileCount = 0;
            if (_isSubDirCheck)
            {
                list = GetFilesDeep(_strDir);
            }
            else
            {
                list = GetFiles(_strDir);
            }
            _ProcCount = 0;

            _ImageLoadStatus = ImageLoadStatus.Busy;
            foreach (String sFilePath in list)
            {
                this.AddImage(sFilePath);
                _ProcCount++;
                while (_ImageLoadStatus == ImageLoadStatus.Stop)
                {
                    Thread.Sleep(1000);
                }
                if (_ImageLoadStatus == ImageLoadStatus.End)
                {
                    //f
                    break;
                }
                //Invoke(new MainThreadCtrl(SetCount));
                //this.tlblStatus.Text = m_ProcCount + "/" + m_FileCount;
            }
            _ImageLoadStatus = ImageLoadStatus.End;

            Debug.WriteLine("摜ǂݍ݃XbhI");
        }


        /// <summary>
        /// t@Cǂݍ
        /// </summary>
        /// <param name="sCurrentDir">JgfBNgpX</param>
        /// <returns></returns>
        private List<String> GetFiles(string sCurrentDir)
        {
            List<String> list = new List<String>();
            if (_MaxRead <= _FileCount) return list;
            foreach (string sFilePath in Directory.GetFiles(sCurrentDir, "*.jpg"))
            {
                if (_MaxRead <= _FileCount) return list;
                list.Add(sFilePath);
                _FileCount++;
            }
            foreach (string sFilePath in Directory.GetFiles(sCurrentDir, "*.png"))
            {
                if (_MaxRead <= _FileCount) return list;
                list.Add(sFilePath);
                _FileCount++;
            }
            foreach (string sFilePath in Directory.GetFiles(sCurrentDir, "*.gif"))
            {
                if (_MaxRead <= _FileCount) return list;
                list.Add(sFilePath);
                _FileCount++;
            }
            foreach (string sFilePath in Directory.GetFiles(sCurrentDir, "*.bmp"))
            {
                if (_MaxRead <= _FileCount) return list;
                list.Add(sFilePath);
                _FileCount++;
            }
            return list;
        }

        /// <summary>
        /// tH_ANZX
        /// </summary>
        /// <param name="sCurrentDir">JgfBNgpX</param>
        /// <returns></returns>
        public List<String> GetFilesDeep(string sCurrentDir)
        {

            List<String> list = GetFiles(sCurrentDir);
            // ̃fBNĝׂẴTufBNg (ċA)
            foreach (string stDirPath in Directory.GetDirectories(sCurrentDir))
            {
                List<String> listFile = GetFiles(stDirPath);

                // ɍvt@Cꍇ́AArrayList ɉ
                if (listFile.Count > 0)
                {
                    list.AddRange(listFile.ToArray());
                }
            }

            return list;
        }


#endregion
    
    }

    /// <summary>
    /// 摜t@Cǂݍݏ
    /// </summary>
    public enum ImageLoadStatus
    {
        Start,
        Busy,
        Stop,
        End
    }

}
