using System;
using System.Threading;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Diagnostics;
using System.Collections.Generic;
namespace PhotoMosaic
{
    //UCN`Xe[^X
    public enum MosaicStatus
    {
        Start,
        Busy,
        Stop,
        End
    }


    /// <summary>
    /// `XbhNXĂ݂
    /// </summary>
    class Mosaic : IDisposable
    {

#region o
        //UCNXbh
        private Thread _MosaicThread;
        //`Ώ
        private Bitmap _MosaicImage;
        //摜
        private Bitmap _BaseImage;

        //XbhɎw
        private MosaicStatus _DrawRequest;
        //݂̃Xbh
        private MosaicStatus _MosaicStatus;

        private int _BaseTileSize = 4;
        //UCNp^[TCY
        private int _TileSize;
        //{
        private float _ratio = 1F;
        private float _PreRatio = 1F;
        //摜̈ʒuƑ傫
        private Rectangle _ImageRect;
        //摜̃TCY
        private Size _BaseImageSize;
        //LoXTCY
        private Size _ImageSize;
        //摜ǗNX
        private ImgStCtrl _ImgStCtrl;
        //bNIuWFNg
        private object _syncObject;

        private Boolean isSetBackImageBusy;

        private Boolean _SelectMode;

        //摜I[hɎgt@CXg
        private List<String> _listTileFileNames;

        //^Ci
        private InterpolationMode _qt;

        /// <summary>
        /// Xbh̏
        /// </summary>
        public MosaicStatus MosaicStatus
        {
            get { return _MosaicStatus; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Width
        {
            get { return _ImageSize.Width; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Height
        {
            get { return _ImageSize.Height; }
        }

        /// <summary>
        /// X
        /// </summary>
        public int X
        {
            get { return _ImageRect.X; }
        }

        /// <summary>
        /// Y
        /// </summary>
        public int Y
        {
            get { return _ImageRect.Y; }
        }

        /// <summary>
        /// 摜Ipt@CpXXg
        /// </summary>
        public List<String> FilePathList
        {
            get { return _listTileFileNames; }
        }
#endregion

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="BaseImage">摜</param>
        /// <param name="BaseTileSize">{P̎̃^CTCY</param>
        /// <param name="Ratio">{</param>
        /// <param name="ImageRect">摜ʒuƃTCY</param>
        /// <param name="PicSize">\̈̃TCY</param>
        /// <param name="ImgStCtrl">UCNǗNX</param>
        /// <param name="SyncObj">pIuWFNg</param>
        public Mosaic(
                Bitmap BaseImage,
                int BaseTileSize,
                float Ratio,
                Rectangle ImageRect,
                Size PicSize,
                ImgStCtrl ImgStCtrl,
                Boolean SelectMode,
                InterpolationMode qt,
                object SyncObj)
        {
            _BaseImage = BaseImage;
            _BaseTileSize = BaseTileSize;
            _ratio = Ratio;
            _ImgStCtrl = ImgStCtrl;
            _syncObject = SyncObj;
            _SelectMode = SelectMode;
            _qt = qt;

            _ImageRect = new Rectangle(ImageRect.Location,ImageRect.Size);
            _ImageSize = new Size(PicSize.Width,PicSize.Height);
            _TileSize = (int)(BaseTileSize * Ratio);
            _BaseImageSize = new Size(_BaseImage.Width, _BaseImage.Height);
            _MosaicImage = new Bitmap(PicSize.Width, PicSize.Height);
            _ImageSize = new Size(PicSize.Width, PicSize.Height);
            _PreRatio = _ratio;
            if (_SelectMode)
            {
                _listTileFileNames = new List<String>();
            }

        }

        /// <summary>
        /// J
        /// </summary>
        public void Dispose()
        {
            if (_MosaicImage != null)
            {
                _DrawRequest = MosaicStatus.End;//Xbh~wē
                _MosaicImage.Dispose();
                _MosaicImage = null;
            }
        }

        /// <summary>
        /// XbhJn
        /// </summary>
        public void Start()
        {
            _MosaicThread = new Thread(new ThreadStart(DrawMosaic));
            _MosaicThread.IsBackground = true;
            _MosaicStatus = MosaicStatus.Start;
            _MosaicThread.Start();
        }

        /// <summary>
        /// ړ &{w
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void Move(int x, int y, float Ratio)
        {
            //
            if (_ImageRect.X == x && _ImageRect.Y == y)
            {
                //ʒuɕωȂ
                return;
            }
            if (isSetBackImageBusy)
            {
                //SetBackImage()XLbv
                return;
            }
            if(Ratio != _PreRatio) _PreRatio = _ratio;
            _ratio = Ratio;
            ThreadEnd();
            _ImageRect.X = x;
            _ImageRect.Y = y;
            SetBackImage();
        }

        /// <summary>
        /// `
        /// </summary>
        /// <param name="DestImage"></param>
        public void Draw(Graphics g)
        {
            lock (_syncObject)
            {
                lock (this)
                {
                    g.DrawImage(_MosaicImage, 0, 0);
                }
            }
        }

        /// <summary>
        /// Xbh~
        /// </summary>
        public void ThreadEnd()
        {
            _DrawRequest = MosaicStatus.End;
        }

        /// <summary>
        /// Xbh~܂ŃCXbh~
        /// </summary>
        public void ThreadJoin()
        {
            if (_MosaicThread != null)
            {
                if (_MosaicThread.IsAlive)
                {
                    _DrawRequest = MosaicStatus.End;
                    _MosaicThread.Join();
                }
            }
        }

        /// <summary>
        /// ܂摜`
        /// </summary>
        private void SetBackImage()
        {
            isSetBackImageBusy = true;
            int xStart = (int)(_ImageRect.X / _ratio);
            int yStart = (int)(_ImageRect.Y / _ratio);
           
            int width = (int)(_ImageSize.Width / _ratio);
            int height = (int)(_ImageSize.Height / _ratio);
            //if (yStart < 0) yStart = 0;
            //if (xStart < 0) xStart = 0;

            lock (this)
            {
                using (Graphics g = Graphics.FromImage(_MosaicImage))
                {
                    Rectangle dest = new Rectangle(0, 0, _MosaicImage.Width, _MosaicImage.Height);
                    g.FillRectangle(Brushes.LightGray, dest);
                    Bitmap mini = new Bitmap(width, height);
                    Rectangle src = new Rectangle(-xStart, -yStart, width, height);
                    Rectangle src2 = new Rectangle(0, 0, width, height);
                    using (Graphics gg = Graphics.FromImage(mini))
                    {
                        gg.DrawImage(_BaseImage, src2, src, GraphicsUnit.Pixel);
                    }
                    g.DrawImage(mini, dest);
                }
            }
            isSetBackImageBusy = false;
        }

        /// <summary>
        ///@UCN摜쐬
        /// </summary>
        private void DrawMosaic()
        {
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Debug.WriteLine("UCN쐬Jn");
            //\ʒu
            int yStart = -(int)(_ImageRect.Y / _ratio);
            int xStart = -(int)(_ImageRect.X / _ratio);
            int yyStart = 0;
            int xxStart = 0;
            if (yStart < 0)
            {
                yyStart = Math.Abs(yStart);
                yStart = 0;
            }
            if (xStart < 0)
            {
                xxStart = Math.Abs(xStart);
                xStart = 0;
            }

            //TCY
            int height = (int)(_ImageSize.Height / _ratio);
            int width = (int)(_ImageSize.Width / _ratio);
            if (height > _BaseImageSize.Height) height = _BaseImageSize.Height;
            if (width > _BaseImageSize.Width) width = _BaseImageSize.Width;

            _MosaicStatus = MosaicStatus.Busy;
            SetBackImage();
            height += yStart;
            width += xStart;

            int yy = yyStart;
            for (int y = yStart; y < height; y += _BaseTileSize)
            {
                int xx = xxStart;
                for (int x = xStart; x < width; x += _BaseTileSize)
                {
                    try
                    {
                        Color clr = _BaseImage.GetPixel(x, y);//摜F擾
                        ImageStatus imgst = _ImgStCtrl.GetApproximate(clr);
                        if (_SelectMode)
                        {
                            _listTileFileNames.Add(imgst.FilePath);
                        }
                        lock (this)
                        {
                            if (_TileSize == 1)
                            {
                                //^CTCY1pixel̏ꍇ͕ϐFgĕ`
                                _MosaicImage.SetPixel(x, y, imgst.AveColor);
                            }
                            else
                            {
                                using (Graphics g = Graphics.FromImage(_MosaicImage))
                                {
                                    g.InterpolationMode = _qt;
                                    g.DrawImage(imgst.Thumb, xx, yy, _TileSize, _TileSize);
                                }
                            }
                        }
                    }
                    catch (Exception)
                    {
                        //Ă݂
                    }
                    //this.pic.Invalidate();//1_`ɕ`

                    if (_DrawRequest == MosaicStatus.End)
                    {
                        //Iw烋[v𔲂
                        Debug.WriteLine("UCN쐬f");
                        goto LoopOut;
                    }
                    xx += _TileSize;
                }
                yy += _TileSize;
            }
        LoopOut:
            _MosaicStatus = MosaicStatus.End;
            sw.Stop();
            Debug.WriteLine("UCN쐬I:" + sw.ElapsedMilliseconds + "ms");
            Debug.WriteLine("QT=" + _qt);
        }
    }
}
