using System;
using System.Drawing;
using System.Diagnostics;

namespace PhotoMosaic
{
    class MosaicCtrl : IDisposable
    {

#region o

        //bNIuWFNg
        private object _syncObject;
        private ImgStCtrl _ImgStCtrl;
        private Bitmap _BaseImage;
        private Mosaic _Mosaic;

        public Mosaic Mosaic
        {
            get { return _Mosaic; }
        }

#endregion


#region EI
        /// <summary>
        /// RXgN^
        /// </summary>
        public MosaicCtrl(
                ImgStCtrl ImgStCtrl,
                object SyncObj)
        {
            _syncObject = SyncObj;
            _ImgStCtrl = ImgStCtrl;
        }

        /// <summary>
        /// J
        /// </summary>
        public void Dispose()
        {
            if (_Mosaic != null)
            {
                _Mosaic.Dispose();
            }
        }

        /// <summary>
        /// UCN
        /// </summary>
        public void InitMosaic()
        {
            if (_Mosaic != null)
            {
                _Mosaic.Dispose();
                _Mosaic = null;
            }
        }
#endregion

        /// <summary>
        /// 摜w
        /// </summary>
        /// <param name="BaseImage"></param>
        public void SetBaseImage(Bitmap BaseImage)
        {
            _BaseImage = BaseImage;
            if (_Mosaic != null)
            {
                _Mosaic.Dispose();
                _Mosaic = null;
            }
        }

        /// <summary>
        /// TCY
        /// </summary>
        /// <param name="width"></param>
        /// <param name="height"></param>
        public void Resize(int width, int height)
        {
            //
        }

        /// <summary>
        /// ړ
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void Move(int x, int y,float ratio)
        {
            if (_Mosaic != null)
            {
                _Mosaic.Move(x, y, ratio);
            }
        }

        /// <summary>
        /// UCN`Jn
        /// </summary>
        /// <param name="Ratio">g嗦</param>
        /// <param name="ImageRect">摜ʒuƑ傫</param>
        /// <param name="PicSize">\̈̑傫</param>
        public void NewDraw(
                float Ratio,
                Rectangle ImageRect,
                Size PicSize)
        {
            if (_Mosaic != null)
            {
                //݂̃XbhJ
                _Mosaic.Dispose();
            }
            AppConfig conf = Config.GetInstance().AppConfig;
            int InitTileSize = conf.InitTileSize;
            Boolean SelectMode = false;
            System.Drawing.Drawing2D.InterpolationMode qt = Config.ImageQuality(conf.ThmbQuality);
            if (Ratio >= conf.SelectModeRatio)
            {
                SelectMode = true;
            }
            _Mosaic = new Mosaic(
                            _BaseImage,
                            InitTileSize,
                            Ratio,
                            ImageRect,
                            PicSize,
                            _ImgStCtrl,
                            SelectMode,
                            qt,
                            _syncObject);

            _Mosaic.Start();
        }

        /// <summary>
        /// `
        /// </summary>
        /// <param name="g"></param>
        public void Draw(Graphics g)
        {
            _Mosaic.Draw(g);
        }


    }
}
